#include "testlib.h"

#include <utility>

using namespace std;

const int MAX = 1000000;

typedef pair<long long, long long> ratio;

int n, m;
int a[MAX], v[MAX];

double to_double(ratio r) {
  if (r.second == 0) {
    quitf(_fail, "checker is trying to div by 0");
  }
  return r.first / (double)r.second;
}

bool lt(ratio a, ratio b) {
  return a.first * b.second < b.first * a.second;
}

ratio norm(ratio a) {
  if (a.second < 0) {
    a.first = -a.first;
    a.second = -a.second;
  }
  return a;
}

ratio get_time(int x) {
  ratio ans = std::make_pair(MAX + 1, 1);
  for (int i = 0; i < m; i++) {
    ratio cur = norm(std::make_pair(x - a[i], v[i]));
    if (cur.first >= 0 && lt(cur, ans)) {
      ans = cur;
    }
  }
  return ans;
}

int main(int argc, char * argv[]) {
  registerTestlibCmd(argc, argv);

  n = inf.readInt();
  m = inf.readInt();
  for (int i = 0; i < m; i++) {
    a[i] = inf.readInt();
    v[i] = inf.readInt();
  }

  int ja = ans.readInt();
  if (ja < 1 || ja > n) {
    quitf(_fail, "jury answer %d is out of range [1, %d]", ja, n);
  }

  int pa = ouf.readInt();
  if (pa < 1 || pa > n) {
    quitf(_wa, "program answer %d is out of range [1, %d]", pa, n);
  }

  ratio jtime = get_time(ja);
  ratio ptime = get_time(pa);

  if (lt(jtime, ptime)) {
    quitf(_fail, "jury time %.6lf is less than program time %.6lf",
          to_double(jtime), to_double(ptime));
  }
  if (lt(ptime, jtime)) {
    quitf(_wa, "program time %.6lf is less than jury time %.6lf",
          to_double(ptime), to_double(jtime));
  }

  quitf(_ok, "ok");
}
